package action;

import java.io.IOException;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.jbpm.taskmgmt.exe.TaskInstance;

import action.AllMethods;
/**
 * Servlet implementation class MainServlet
 */
public class MainServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private int j;
	private static MainServlet in;
	public static MainServlet getIn() {
		return in;
	}

	@SuppressWarnings("static-access")
	public void setIn(MainServlet in) {
		this.in = in;
	}

	public int getJ() {
		return j;
	}

	public void setJ(int j) {
		this.j = j;
	}

    /**
     * Default constructor. 
     */
    public MainServlet() {
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		
		RequestDispatcher rd;
		String method = request.getParameter("activity");
		HttpSession session = request.getSession();
		AllMethods allMethods = new AllMethods();
		if (method.equals("Deploy"))
		{
		String pname= allMethods.reDeployProcess("action/processdefinition.xml");
		session.setAttribute("processName", pname);
    	rd = request.getRequestDispatcher("processStart.jsp");
    	rd.forward(request, response);
		
		}
		
		else if(method.equals("Start"))
		{
		String processInstanceId = allMethods.startNewProcessInstance((String)session.getAttribute("processName"));
		session.setAttribute("pID", processInstanceId);
    	rd = request.getRequestDispatcher("started.jsp");
    	rd.forward(request, response);
		}
		
		
		
		else if(method.equals("See pending tasks"))
		{
			List<?> taskList  = allMethods.listAllTasks((String) session.getAttribute("name"));
		    String[] tasks = new String[taskList.size()];
		    int i =0;
		  
		    for(i=0;i<=taskList.size()-1; i++)
		    {
		    TaskInstance task = (TaskInstance) taskList.get(i);
		    tasks[i] = task.getName();
		    }
		    session.setAttribute("TaskArray", tasks);
		    RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/taskList.jsp");
			dispatcher.forward(request, response);
		}
		
		
		
		else if (method.equals("Submit Form"))
		{
			
			 Calendar cal = new GregorianCalendar();
			  int month = cal.get(Calendar.MONTH);
			  int year = cal.get(Calendar.YEAR);
			  int day = cal.get(Calendar.DAY_OF_MONTH);
			
			  month=month+1;
			  
			  
				 String startDate=request.getParameter("startDateOfLeave");
				 String endDate=request.getParameter("endDateOfLeave");
				
				
				 StringTokenizer	st1 = new StringTokenizer(startDate, "/");
				 
				 int startDay = Integer.parseInt(st1.nextToken());
				 int startMonth = Integer.parseInt(st1.nextToken());
				 int startYear = Integer.parseInt(st1.nextToken());
			
				 StringTokenizer	st2 = new StringTokenizer(endDate, "/");

				 int endDay = Integer.parseInt(st2.nextToken());
				 int endMonth = Integer.parseInt(st2.nextToken());
				 int endYear = Integer.parseInt(st2.nextToken());
			
				 
				 System.out.println(+day+"      "+month+"       "+year+"      "+startDay+"        "+startMonth+"         "+startYear);
			Object[] u={new CheckValues(startDay,startMonth,startYear,day,month,year)};
				try {
					new RuleRunner().runRules( new String[] { "action/startDateCheck.drl" },u);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
       
	        MainServlet m=getIn();
	    	if(m.j==1)
			{
	    		System.out.println("Value of j is  "+m.j);
	    		Object[] v={new CheckEndDate(startDay,startMonth,startYear,endDay,endMonth,endYear)};
					try {
						new RuleRunner().runRules( new String[] { "action/endDateCheck.drl" },v);
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
			        MainServlet n=getIn();
				
	    		if(n.j==2)
	    		{
		    		System.out.println("Value of j is  "+n.j);
	    			session.setAttribute("userName", request.getParameter("userName"));
	    			session.setAttribute("startDateOfLeave", startDate);
	    			session.setAttribute("endDateOfLeave", endDate);
	    			session.setAttribute("reasonForLeave", request.getParameter("reasonForLeave"));
	    			allMethods.completeProcess((String)session.getAttribute("processName"), (String)session.getAttribute("pID"), request.getParameter("username"));
	    		}
	    		
	    		else
	    		{
		    		System.out.println("Value of j is  "+n.j);
	    			rd = request.getRequestDispatcher("leaveApplication.jsp");
		        	rd.forward(request, response);
	    		}
	    	}
	        
	        else
	        {
	    		System.out.println("Value of j is  "+m.j);
	        	rd = request.getRequestDispatcher("leaveApplication.jsp");
	        	rd.forward(request, response);
	        }
		}
		
		
		else if (method.equals("Approved"))
		{
			allMethods.completeProcessWithTransition((String)session.getAttribute("processName"), (String)session.getAttribute("pID"),request.getParameter("username"), "Approved");
		}
		
		
		else if (method.equals("Rejected"))
		{
			allMethods.completeProcessWithTransition((String)session.getAttribute("processName"), (String)session.getAttribute("pID"),request.getParameter("username"), "Rejected");		
		}
		
		
		
		else if(method.equals("Login"))
		{
			System.out.println("User In session : "+request.getParameter("username"));
			session.setAttribute("name", request.getParameter("username"));
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/frames.jsp");
			dispatcher.forward(request, response);
		}
		
		else if (method.equals("View"))
		{	
			List<?> taskList  = allMethods.listAllTasks((String) session.getAttribute("name"));
			System.out.println(taskList.size());
		    int i =0;
		    for(i=0;i<=taskList.size()-1; i++)
		    {
		    TaskInstance task = (TaskInstance) taskList.get(i);
			    
			if(task.getName().equals("Apply for leave"))
			{
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/leaveApplication.jsp");
			dispatcher.forward(request, response);	
			return;
			}
			else if(task.getName().equals("Leave approval needed"))
			{
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/leaveApproval.jsp");
			dispatcher.forward(request, response);	
			return;
			}
		  }
	   }
	}

}
